'Pingpongradio6.bas
'UKW-Radio mit Freq-Anzeige
'Radio-Chip SI 4735
'neue Anzeige von Hermann Nieder
'21.04.11

$crystal = 8000000
$regfile = "m8def.dat"
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Leds(12) As Word
Dim X As Byte
Dim Y As Byte
Dim N As Word
Dim I As Word
Dim U As Word

Declare Sub Standby
Declare Sub Test
Declare Sub Initialisierung

Declare Sub Led1(byval X As Byte , Byval Y As Byte)
Declare Sub Led0(byval X As Byte , Byval Y As Byte)


Dim Zeichen As Byte
Dim Splt1 As Word
Dim Splt2 As Word
Dim Splt3 As Word
Dim Splt4 As Word
Dim Spltz1 As Word
Dim Spltz2 As Word
Dim Spltz3 As Word
Dim Spltz4 As Word
Dim Spltz5 As Word
Dim Spltz6 As Word
Dim Spltz7 As Word
Dim Spltz8 As Word
Dim Spltz9 As Word
Dim Spltz10 As Word
Dim Spltz11 As Word
Dim Spltz12 As Word
Dim Tausender As Word
Dim Tausender1 As Word
Dim Hunderter As Word
Dim Hunderter1 As Word
Dim Zehner As Word
Dim Zehner1 As Word
Dim Einer As Byte
Dim Dat As Word
Dim Dat_temp As Word
Dim Z_bit As Bit
'Dim Freq As Word

Dim F As Word
Dim Fr As Word
Dim H As Byte
Dim L As Byte
Dim T As Byte
Dim Poti As Integer
Dim Potialt As Integer
Dim Potidif As Integer
Dim Kanal As Byte
Dim Kanalalt As Byte
Dim R1 As Byte
Dim R2 As Byte
Dim R3 As Byte
Dim Vol As Word
Dim Volalt As Byte


Dim Nmax As Byte
Dim Teilung As Word

Const F1 = 8800
Const F2 = 9030
Const F3 = 9090
Const F4 = 9130
Const F5 = 9200
Const F6 = 9235
Const F7 = 9330
Const F8 = 9550
Const F9 = 9750
Const F10 = 10500


Declare Sub Freq
Declare Sub Scan
Declare Sub Fm_tune_status()
Declare Sub Rx_volume()

Dim Xx As Single
Dim Yy As Single
'



  Config Scl = Portc.5
  Config Sda = Portc.4
  I2cinit

  Waitms 300
  I2cstart
  I2cwbyte 34
  I2cwbyte &H01
  I2cwbyte &H10                                             '00 FM, 01 AM, 10 32-kHz-Osz
  I2cwbyte &H05
  I2cstop
  Waitms 800



Initialisierung

  Kanalalt = 255
  Do
    Poti = Getadc(7)
    'Poti = 1023 - Poti
    Poti = Poti / 102                                       '0...8
    If Poti = 0 Then Kanal = 0
    If Poti = 1 Then Kanal = 1
    If Poti = 2 Then Kanal = 2
    If Poti = 3 Then Kanal = 3
    If Poti = 4 Then Kanal = 4
    If Poti = 5 Then Kanal = 5
    If Poti = 6 Then Kanal = 6
    If Poti = 7 Then Kanal = 7
    If Poti = 8 Then Kanal = 8
    If Poti = 9 Then Kanal = 9
    If Kanal <> Kanalalt Then
      If Kanal = 0 Then F = F1
      If Kanal = 1 Then F = F2
      If Kanal = 2 Then F = F3
      If Kanal = 3 Then F = F4
      If Kanal = 4 Then F = F5
      If Kanal = 5 Then F = F6
      If Kanal = 6 Then F = F7
      If Kanal = 7 Then F = F8
      If Kanal = 8 Then F = F9
      If Kanal = 9 Then F = F10
      Freq
      Kanalalt = Kanal
      Dat = F / 10
      'If Dat > 1000 Then Dat = Dat - 1000
      Select Case Kanal
      Case 0 : Gosub Anz_sr1
      Case 1 : Gosub Anz_mhz
      Case 2 : Gosub Anz_mhz
      Case 3 : Gosub Anz_sr2
      Case 4 : Gosub Anz_mhz
      Case 5 : Gosub Anz_mhz
      Case 6 : Gosub Anz_rtl
      Case 7 : Gosub Anz_sr3
      Case 8 : Gosub Anz_swr
      Case 9 : Gosub Anz_dlf
      End Select

      Gosub Dez_darst



    End If
    Vol = Getadc(6)
    Vol = Vol / 32
    Vol = Vol + 32
    If Vol <> Volalt Then
       Rx_volume
       Volalt = Vol
    End If
  Loop

Do
F = F4

Freq

Waitms 20
Loop


'Darstellung im Dezimalformat
Dez_darst:
Tausender = Dat / 1000
Zeichen = Tausender
If Tausender = 1 Then
Leds(1) = 2 + Spltz1
Leds(2) = 31 + Spltz2
Else
Leds(1) = 0 + Spltz1
Leds(2) = 0 + Spltz2
End If
Tausender1 = Tausender * 1000
Dat = Dat - Tausender1


Hunderter = Dat / 100
Zeichen = Hunderter
Gosub Darstellung1
Hunderter1 = Hunderter * 100
Dat = Dat - Hunderter1
Zehner = Dat / 10
Zeichen = Zehner

Gosub Darstellung2
Zehner1 = Zehner * 10
Dat = Dat - Zehner1
Einer = Dat

Zeichen = Einer
Gosub Darstellung3
Return

'2. Zeichen von links
Darstellung1:                                               '
Gosub Zeichen_z
'Zustzliche Anzeige 'MHz' bzw. Kurzzeichen
'eines Senders

Leds(3) = Splt1 + Spltz3
Leds(4) = Splt2 + Spltz4
Leds(5) = Splt3 + Spltz5

Return
'Zeichen Mitte
Darstellung2:
Gosub Zeichen_z
Leds(6) = Splt1 + Spltz6
Leds(7) = Splt2 + Spltz7
Leds(8) = Splt3 + Spltz8
'Dezimalpunkt
Leds(9) = 16 + Spltz9
Return
'zeichen rechts
Darstellung3:
Gosub Zeichen_z
Leds(10) = Splt1 + Spltz10
Leds(11) = Splt2 + Spltz11
Leds(12) = Splt3 + Spltz12
Return

Anz_ndr:
'Datei: NDR_u1.LED
Spltz1 = 992
Spltz2 = 64
Spltz3 = 128
Spltz4 = 992
Spltz5 = 0
Spltz6 = 992
Spltz7 = 544
Spltz8 = 448
Spltz9 = 0
Spltz10 = 992
Spltz11 = 160
Spltz12 = 832
Return

Anz_wdr:
'Datei: WDR_u1.LED
Spltz1 = 480
Spltz2 = 512
Spltz3 = 384
Spltz4 = 512
Spltz5 = 480
Spltz6 = 992
Spltz7 = 544
Spltz8 = 448
Spltz9 = 0
Spltz10 = 992
Spltz11 = 160
Spltz12 = 832
Waitms 1000

Anz_rtl:
'Datei: RTL_u1.LED
Spltz1 = 992
Spltz2 = 416
Spltz3 = 704
Spltz4 = 0
Spltz5 = 32
Spltz6 = 992
Spltz7 = 32
Spltz8 = 0
Spltz9 = 992
Spltz10 = 512
Spltz11 = 512
Spltz12 = 0
Return


Anz_dlf:
'Datei: DLF1_u1.LED
Spltz1 = 992
Spltz2 = 544
Spltz3 = 448
Spltz4 = 0
Spltz5 = 992
Spltz6 = 512
Spltz7 = 512
Spltz8 = 0
Spltz9 = 992
Spltz10 = 160
Spltz11 = 32
Spltz12 = 0
Return

Anz_hr:
'Datei:HR_u1.LED
Spltz1 = 992
Spltz2 = 128
Spltz3 = 992
Spltz4 = 0
Spltz5 = 992
Spltz6 = 160
Spltz7 = 832
Spltz8 = 0
Spltz9 = 0
Spltz10 = 0
Spltz11 = 0
Spltz12 = 0
Return


Anz_swr:
'Datei: SWR_u1.LED
Spltz1 = 704
Spltz2 = 288
Spltz3 = 0
Spltz4 = 480
Spltz5 = 512
Spltz6 = 384
Spltz7 = 512
Spltz8 = 480
Spltz9 = 0
Spltz10 = 992
Spltz11 = 160
Spltz12 = 832
Return


Anz_mhz:
'Datei: MHz_u1.LED
Spltz1 = 960
Spltz2 = 64
Spltz3 = 384
Spltz4 = 64
Spltz5 = 960
Spltz6 = 0
Spltz7 = 960
Spltz8 = 128
Spltz9 = 960
Spltz10 = 0
Spltz11 = 832
Spltz12 = 704
Return

Anz_sr1:
'Datei: SR1u_1.LED
Spltz1 = 576
Spltz2 = 672
Spltz3 = 288
Spltz4 = 0
Spltz5 = 992
Spltz6 = 160
Spltz7 = 832
Spltz8 = 0
Spltz9 = 0
Spltz10 = 64
Spltz11 = 992
Spltz12 = 0
Return

Anz_sr2:
'Datei: SR2u_1.LED
Spltz1 = 576
Spltz2 = 672
Spltz3 = 288
Spltz4 = 0
Spltz5 = 992
Spltz6 = 160
Spltz7 = 832
Spltz8 = 0
Spltz9 = 768
Spltz10 = 672
Spltz11 = 576
Spltz12 = 0
Waitms 1000
Return
Anz_sr3:
'Datei: SR3u_1.LED
Spltz1 = 576
Spltz2 = 672
Spltz3 = 288
Spltz4 = 0
Spltz5 = 992
Spltz6 = 160
Spltz7 = 832
Spltz8 = 0
Spltz9 = 544
Spltz10 = 672
Spltz11 = 320
Spltz12 = 0
Return

'Die Muster fr die Zeichen (Ziffern der Anzeige)
'wurden mit dem Programm "Super-Mustergenerator"
'entwickelt und die Werte daraus jeweils in die
'Programmzeilen Splt1..Splt4 bernommen.
Zeichen_z:
Select Case Zeichen
Case 0:
Splt1 = 14
Splt2 = 17
Splt3 = 14
Case 1:
Splt1 = 2
Splt2 = 31
Splt3 = 0
Case 2:
Splt1 = 24
Splt2 = 21
Splt3 = 19
Case 3:
Splt1 = 17
Splt2 = 21
Splt3 = 27
Case 4:
Splt1 = 7
Splt2 = 28
Splt3 = 4
Case 5:
Splt1 = 23
Splt2 = 21
Splt3 = 8
Case 6:
Splt1 = 14
Splt2 = 21
Splt3 = 8
Case 7:
Splt1 = 1
Splt2 = 29
Splt3 = 3
Case 8:
Splt1 = 10
Splt2 = 21
Splt3 = 10
Case 9:
Splt1 = 6
Splt2 = 21
Splt3 = 14
End Select
Return



Do
 For N = 1 To 60000
  For X = 1 To 12
    Xx = X * 30
    Xx = Xx - N
    Xx = Xx / 60
    Yy = Sin(xx)
    Yy = Yy + 1
    Yy = Yy * 5
    Yy = Yy + 1
    Y = Int(yy)
    Leds(x) = 0
    Led1 X , Y
  Next X
 Next N
 Standby
Loop



Sub Led1(byval X As Byte , Byval Y As Byte)
 If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 1
    Case 2 : Leds(x).8 = 1
    Case 3 : Leds(x).7 = 1
    Case 4 : Leds(x).6 = 1
    Case 5 : Leds(x).5 = 1
    Case 6 : Leds(x).4 = 1
    Case 7 : Leds(x).3 = 1
    Case 8 : Leds(x).2 = 1
    Case 9 : Leds(x).1 = 1
    Case 10 : Leds(x).0 = 1
   End Select
  End If
End Sub

Sub Led0(byval X As Byte , Byval Y As Byte)
 If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 0
    Case 2 : Leds(x).8 = 0
    Case 3 : Leds(x).7 = 0
    Case 4 : Leds(x).6 = 0
    Case 5 : Leds(x).5 = 0
    Case 6 : Leds(x).4 = 0
    Case 7 : Leds(x).3 = 0
    Case 8 : Leds(x).2 = 0
    Case 9 : Leds(x).1 = 0
    Case 10 : Leds(x).0 = 0
   End Select
  End If
End Sub


'******************  Service-Unterprogramme *********************


Sub Initialisierung
  Config Portc = 15                                         'PORTC als AD-Eingang
  Config Portb = Output
  Config Portd = 255
  Config Timer2 = Timer , Prescale = 8
  On Ovf2 Tim2_isr
  Enable Timer2
  Enable Interrupts
  Start Timer2
  Config Adc = Single , Prescaler = 64 , Reference = Off
  Start Adc
  Config Int0 = Low Level                                   'Falling
  On Int0 Int_isr
End Sub


Sub Standby
  Stop Timer2
  Portc = 0
  Portd = 0
  Portb = 0
  Stop Adc
  Ddrd.2 = 0
  Portd.2 = 1
  Enable Int0
  Powerdown
  Ddrd.2 = 1
  Portd.2 = 0
  Start Adc
  Start Timer2
End Sub


Dim Vhelp As Word

Sub Test
      For X = 1 To 12
         Leds(x) = 1023
      Next X
      Waitms 1000
      For X = 1 To 12
         For Y = 1 To 12
            Leds(y) = 0
         Next Y
         Leds(x) = 1023
         Waitms 100
      Next X
      For Y = 1 To 10
         For X = 1 To 12
            Vhelp = Y - 1
            Vhelp = 2 ^ Vhelp
            Leds(x) = Vhelp
         Next X
         Waitms 100
      Next Y
      For X = 1 To 12
         Leds(x) = 0
      Next X
End Sub






Sub Freq
  I2cstart
  I2cwbyte 34
  I2cwbyte &H20
  I2cwbyte &H00
  H = High(f)
  L = Low(f)
  I2cwbyte H
  I2cwbyte L
  I2cwbyte &H00
  I2cstop
End Sub

Sub Scan
  I2cstart
  I2cwbyte 34
  I2cwbyte &H21
  I2cwbyte &H08
  I2cstop
End Sub

Sub Fm_tune_status()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H22
  I2cwbyte &H3
  I2cstop
  I2cstart
  I2cwbyte 35
  I2crbyte R1 , Ack
  I2crbyte R1 , Ack
  I2crbyte R2 , Ack
  I2crbyte R3 , Ack
  I2crbyte R1 , Nack
  F = 256 * R2
  F = F + R3
  I2cstop
End Sub

Sub Rx_volume()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H12
  I2cwbyte &H00
  I2cwbyte &H40
  I2cwbyte &H00
  I2cwbyte &H00
  I2cwbyte Vol
  I2cstop
End Sub



Int_isr:
  Disable Int0
Return


'******************************* Interrupt - Display ****************************

Dim Vy As Byte
Dim Col As Byte
Dim Portdout As Byte
Dim Portcout As Byte


Tim2_isr:
 '800 s
'Timer2 = 56
Col = Col + 1
If Col = 13 Then Col = 1
Vy = Col + 0
Portd = 0
Portb = 0
Portc = 0
If Col = 1 Then Portb.4 = 0 Else Portb.4 = 1
Portb.3 = 1                                                 'cl
Portb.3 = 0
Portb.2 = 1                                                 'Str
Portb.2 = 0
Portdout = Low(leds(vy))
Portcout = Portdout And 15
Portdout = Portdout And 240
Portd = Portdout
Portc = Portcout
Portb = High(leds(vy))
'Waitms 500
Return
End